/* Mail sorter v.1.0 */
/* Copyright (c)29.11.1996 by Marek Zelem <marek@crazy.elf.stuba.sk> */
/* All rights reserved. */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <pwd.h>
#include <ctype.h>
#include <string.h>

#define MAX_HEAD	(8*1024)
//#define	MLOCK_PATH	"/var/spool/mail/.mlock"

char head[MAX_HEAD];

int string_to_argv( char *av[], char *s, int max )
{ int i,j,p;
	i=0;
	j=0;
	max-=1;
	while(i<max && s[j]!=0)
	{	while(s[j]==' ' || s[j]=='\t') j++;
		if(s[j]=='\"')
		{ j++;
		  p=j;
		  while(s[j]!='\"' && s[j]!=0) j++;
		}
		else
		{ p=j;
		  while(s[j]!=' ' && s[j]!='\t' && s[j]!=0) j++;
		}
		if(s[j]!=0)
			s[j++]=0;
		av[i++]=s+p;
	}
	av[i]=NULL;
	return(i);
}

char *vyberstr( char *buf, char *h, int cs )
{ int i,j;
// !!!!! ak na novom riadku , tak pokracuje ....
   i=0; j=0;
G_vyberstr:
   if(cs)
   {	for(;j<4096 && h[i]!=0 && h[i]!='\n';)
	{	buf[j++]=h[i++];	}
   }
   else
   {	for(;j<4096 && h[i]!=0 && h[i]!='\n';)
	{	buf[j++]=toupper(h[i++]);	}
   }
   if( h[i]=='\n' && ( h[i+1]=='\t' || h[i+2]==' ' ) )
   { buf[j++]=' '; i+=2; goto G_vyberstr;	}
   buf[j]=0;
   return(buf);
}

/* Vyber adresu z listu */
char *vyberadresu( char *buf, char *h )
{ int i,j;
	j= -2;
	for(i=0;i<1024 && h[i]!=0 && h[i]!='\n';i++)
	{ if(j== -2 && h[i]=='<') j= -1;
	  else if( j== -1 && h[i]!=' ' ) {buf[0]=h[i];j=1;}
	  else if( j>0 && (h[i]==' '|| h[i]=='>') ) {buf[j]=0;j= -3;}
	  else if( j>0 )
		buf[j++]=h[i];
	}
	if(j== -2 || j== -1) j=0;
	if( j>=0 )
		buf[j]=0;
	return(buf);
}


void proces_mail( char *name, char *home )
{ char pom[4096];
  char fn[128],buf[1024],buf2[1024];
  char fnh[128],fnt[128],fna[128];
  char reply_to[128];
  FILE *f,*f1,*f2;
  int p[2],fd;
  int pos,len;
  int p_from,p_to,p_cc,p_subject,p_date;
  int is_head;
  int n,cs,i,zt;
  char *av[16];
  int status;
  int ulozene;
   ulozene=0;
   pos=0; head[0]=0;
   p_from=p_to=p_cc=p_subject=p_date=-1;
   is_head=1;

   while(is_head)
   {	if( fgets(head+pos,MAX_HEAD-pos,stdin)==NULL ) is_head=0;
	else if( !strcmp(head+pos,"\n") )	is_head=0;
	else if( !strncmp(head+pos,"From: ",6) )	p_from=pos+6;
	else if( !strncmp(head+pos,"To: ",4) )	p_to=pos+4;
	else if( !strncmp(head+pos,"Cc: ",4) )	p_cc=pos+4;
 	else if( !strncmp(head+pos,"cc: ",4) )	p_cc=pos+4;
	else if( !strncmp(head+pos,"Subject: ",9) )	p_subject=pos+9;
	else if( !strncmp(head+pos,"Date: ",6) )	p_date=pos+6;
	if( is_head )
		pos+=strlen(head+pos);
	if(pos>=MAX_HEAD)
		is_head=0;
   }
   sprintf(fnh,"%s/%s.%d.head",MLOCK_PATH,name,getpid());
   sprintf(fnt,"%s/%s.%d.text",MLOCK_PATH,name,getpid());
   sprintf(fna,"%s/%s.%d.all",MLOCK_PATH,name,getpid());

   if( (f=fopen(fnh,"w+"))!=NULL )
   {	fwrite(head,pos,1,f);
   	fprintf(f,"\n");
	fclose(f);
   }
   if( (f=fopen(fna,"w+"))!=NULL && (f2=fopen(fnt,"w+"))!=NULL )
   {	fwrite(head,pos,1,f);
   	fprintf(f,"\n");
   	while( (len=fread(buf,1,1024,stdin))>0 )
   	{	fwrite(buf,1,len,f);
   		fwrite(buf,1,len,f2);
	}
   	fprintf(f,"\n");
   	fprintf(f2,"\n");
   	fclose(f);
	fclose(f2);
   }

/* Teraz je mail rozdeleny: fnh -hlavicka, fnt -obsah, fna -cely */

   sprintf(fn,"%s/.mailsortrc",home);
   if( (f=fopen(fn,"r"))!=NULL )
   {	sprintf(fn,"/var/spool/mail/%s",name);
	n=1;
	while( n<2 && fgets(buf,1024,f)!=NULL )
   	{  if(buf[strlen(buf)-1]=='\n')	buf[strlen(buf)-1]=0;
	   if( n==1 )
	   {
	    cs=1;
	    if( islower(buf[0]) )
	    { 	for(i=0;buf[i]!=0;i++)
	    		buf[i]=toupper(buf[i]);
	    	 cs=0;
	    }
	    if(buf[0]=='/')	sprintf(buf,"-/var/spool/mail/%s",name);
   	    if(buf[0]=='F')
   	    { if(p_from>=0 && strstr(vyberstr(pom,head+p_from,cs),buf+1)!=NULL) n=1; else n=0; }
   	    else if(buf[0]=='T')
   	    { if(p_to>=0 && strstr(vyberstr(pom,head+p_to,cs),buf+1)!=NULL) n=1; else n=0; }
	    else if(buf[0]=='C')
   	    { if(p_to>=0 && strstr(vyberstr(pom,head+p_cc,cs),buf+1)!=NULL) n=1; else n=0; }
   	    else if(buf[0]=='S')
   	    { if(p_subject>=0 && strstr(vyberstr(pom,head+p_subject,cs),buf+1)!=NULL) n=1; else n=0; }
   	    else if(buf[0]=='D')
   	    { if(p_date>=0 && strstr(vyberstr(pom,head+p_date,cs),buf+1)!=NULL) n=1; else n=0; }
	    else if(buf[0]=='.')
	    { n=2; }
	    else if(buf[0]=='-')
	    {   if( buf[1]=='/' ) sprintf(fn,"%s",buf+1);
		else sprintf(fn,"%s/%s",home,buf+1);
		n=1;
		if( (f2=fopen(fn,"a+"))!=NULL && (f1=fopen(fna,"r"))!=NULL )
		{ while( (len=fread(buf2,1,1024,f1))>0 )
			fwrite(buf2,1,len,f2);
			fprintf(f2,"\n");
			fclose(f2);
			fclose(f1);
			ulozene++;
		}
	    }
	    else if( buf[0]=='|' || buf[0]==':' || buf[0]=='!' )
	    { switch(buf[0])
	      { case '|':  strcpy(fn,fna); break;
	        case ':':  strcpy(fn,fnt); break;
	        case '!':  strcpy(fn,fnh); break;
	      }
	      zt=1;
	      if( buf[1]=='\\' ) zt=2;
	      vyberadresu(reply_to,head+p_from);
	      if( (fd=open(fn,O_RDONLY,0))>=0 )
	      { pipe(p);
		if( fork()==0 )
		{ close(0);
		  dup2(fd,0);
		  close(1);
		  dup2(p[1],1);
		  setenv("FROM",reply_to,1);
		  setenv("TO",vyberstr(pom,head+p_to,1),1);
		  setenv("CC",vyberstr(pom,head+p_cc,1),1);
		  setenv("SUBJECT",vyberstr(pom,head+p_subject,1),1);
		  setenv("DATE",vyberstr(pom,head+p_date,1),1);
		  setenv("NAME",name,1);
		  setenv("HOME",home,1);
		  string_to_argv(av,buf+zt,16);
		  execv(av[0],av);
		}
		ulozene++;
		if( buf[1]!='\\' && fork()==0 )
		{ close(0);
		  dup2(p[0],0);
		  strcpy(buf,"/usr/bin/sendmail");
/*		  strcpy(buf,"/bin/mail");	*/
		  av[0]=buf;
		  av[1]=reply_to;
		  av[2]=NULL;
		  execv(buf,av);
		}
		else	ulozene--;
		wait(&status);
		close(p[0]); close(p[1]); close(fd);
	      }
	    }
	    else if( buf[0]=='@' )
	    { strcpy(reply_to,buf+1);
	      strcpy(fn,fna);
	      if( (fd=open(fn,O_RDONLY,0))>=0 )
	      { ulozene++;
		if( fork()==0 )
		{ close(0);
		  dup2(fd,0);
		  strcpy(buf,"/usr/bin/sendmail");
		  av[0]=buf;
		  string_to_argv(av+1,reply_to,15);
		  execv(buf,av);
		}
		else ulozene--;
		wait(&status);
	      }
	    }
	   }
	   else if( n==0 )
	   { if( buf[0]=='.' || buf[0]==';' ) n=1;
	   }
   	}
	fclose(f);
   }
   else
	sprintf(fn,"/var/spool/mail/%s",name);
   if(ulozene<=0)
   { sprintf(fn,"%s/UNSORTED_MAIL",home); n=1;
		if( (f2=fopen(fn,"a+"))!=NULL && (f1=fopen(fna,"r"))!=NULL )
		{ while( (len=fread(buf2,1,1024,f1))>0 )
			fwrite(buf2,1,len,f2);
			fprintf(f2,"\n");
			fclose(f2);
			fclose(f1);
			ulozene++;
		}
   }
   unlink(fnh);
   unlink(fnt);
   unlink(fna);
   return;
}



int main( int argc, char *argv[] )
{ int fd;
  struct passwd *p;
  char fname[128];
  char buf[1024];
  char home[128];
  char name[64];

   if( (p=getpwuid(getuid()))==NULL )      return(-1);
   strcpy(name,p->pw_name);
   strcpy(home,p->pw_dir);

   sprintf(buf,"%d\n",getpid());
   sprintf(fname,"%s/%s.%d",MLOCK_PATH,name,getuid());
   for(;;)
   {
	if( (fd=open(fname, O_WRONLY | O_CREAT | O_EXCL, 0600))<0 )
	{ FILE *ffd;
	  int pid;
		if( (ffd=fopen(fname, "r"))==NULL ) continue;
		fscanf(ffd, "%d", &pid);
		fclose(ffd);
		sprintf(buf, "/proc/%d", pid);
		if( access(buf, F_OK)<0 ) unlink(fname);
		else	sleep(2);
	}
	else
	{	sprintf(buf, "%d\n",getpid());
		write(fd, buf, strlen(buf));
		close(fd);
		break;
	}	
   }
/*  Tato cast bezi v jednom okamihu len raz pre jedneho uzivatela  */

   proces_mail(name,home);

/*  Uvolnenie miesta dalsim  */
   unlink(fname);
   return(0);
}
